package vc.thinker.absctacts.mqtt.publish;

import lombok.extern.slf4j.Slf4j;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.MqttMessage;

/**
 * mqtt 指令发送
 *
 * @author HeTongHao
 * @since 2019-10-29 16:00
 */
@Slf4j
public class MqttCommandPush {
    public MqttCommandPush(MqttClient mqttClient) {
        this.mqttClient = mqttClient;
    }

    private final MqttClient mqttClient;

    public MqttClient getMqttClient() {
        return mqttClient;
    }

    public void sendMqttMessage(String topic, byte[] payload) {
        MqttMessage message = new MqttMessage();
        message.setPayload(payload);
        message.setQos(1);
        message.setRetained(false);
        try {
            if (mqttClient == null) {
                log.error("命令推送失败 mqttClient is null");
            } else if (mqttClient.isConnected()) {
                mqttClient.publish(topic, message);
            } else {
                mqttClient.connect();
                mqttClient.publish(topic, message);
            }
        } catch (MqttException e) {
            e.printStackTrace();
        }
    }
}
